﻿using System;
using System.Collections.ObjectModel;
using Microsoft.Phone.Controls;
using System.Windows.Media;
using Telerik.Windows.Controls;
using System.Windows.Controls;

namespace SampleProject
{
    public partial class MainPage : PhoneApplicationPage
    {
        ViewModel vm;
        public MainPage()
        {
            this.InitializeComponent();
            vm = new ViewModel();
            this.DataContext = vm;
        }

        private void Button_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            dblb.BringIntoView(vm.Items[20]);
            Dispatcher.BeginInvoke(() =>
            {
                foreach (var item in dblb.ViewportItems)
                {
                    if (item.DataContext == vm.Items[20])
                    {
                        var top = Canvas.GetTop(item);
                        var sv = ElementTreeHelper.FindVisualDescendant<ScrollViewer>(dblb);
                        sv.ScrollToVerticalOffset(top);
                    }
                }
            });
        }
    }

    public class Item
    {
        public double Value { get; set; }

        public string Text { get; set; }
    }

    public class ViewModel
    {
        private static Random rand = new Random();

        public ViewModel()
        {
            this.Items = this.GetData();
        }

        public ObservableCollection<Item> Items { get; set; }

        private ObservableCollection<Item> GetData()
        {
            var data = new ObservableCollection<Item>();
            for (var i = 0; i < 1000; i++)
            {
                data.Add(new Item { Value = rand.Next(10, 15), Text = string.Format("item {0}", i) });
            }

            return data;
        }
    }
}